#include <GL/glut.h>
#include <stdlib.h>
#include <math.h>
#include <assert.h>
#include "traqueboule.h"
#include "argumentParser.h"

#include "global.h"

#include "systeme.h"

// Utilis pour essayer diffrents types de rendu
// Utilis via le paramtre "-t" en ligne de commande
enum { TRANSF=0, SYSTEME=1, TERRE=2 };
unsigned int type = TRANSF;

unsigned int W_fen = 800;  // largeur fenetre
unsigned int H_fen = 800;  // hauteur fenetre


//
// FIN DES HEADERS
//

void dessinerRepere( float taille )
{
	glDisable( GL_LIGHTING );
	glLineWidth( 3 );
	
	// COMPLETER
	
	// END COMPLETER
	
	glEnable( GL_LIGHTING );
}

void dessinerTransf( )
{
	dessinerRepere( 1.0 );
	
	// A dcommenter
	//glTranslatef( 0.4, 0.3, 0.4 );
	//dessinerRepere( 1.0 );
}




Astre *astres;

Astre *soleil;
Astre *terre;
unsigned int nAstres = 0;


uint NX=10;
uint NY=10;
/**
 * Dessiner un astre  la position courante de la matrice modelview (0,0,0)
 * Puis dessine ses satellites
 */
void dessinerAstre( Astre* a )
{
	if( a == soleil )
	{
		// Si c'est le soleil, dsactiver l'clairage pour pouvoir 
		// afficher la sphre de la bonne couleur (comme la lumire est en son centre
		glDisable( GL_LIGHTING );
	}
	// Pas de couleur ambiante
	float MatAmb[4] = {0,0,0,1};
	glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,MatAmb);
	
	// Envoie directement le pointeur vers les 4 float ("fv")
	//glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE, a->diff );
	glColor4fv( a->diff );
	
	glShadeModel( GL_SMOOTH );
	glutSolidSphere( a->r, NX, NY );
	
	if( a == soleil )
	{
		glEnable( GL_LIGHTING );
	}
	
	// Maintenant dessiner les satellites
	// A COMPLETER

	// END COMPLETER

}





void dessinerSysteme()
{
	
	dessinerAstre( soleil );
	
	// Mthode brute
	// La distance de la terre au soleil vaut "terre->d"
	// A COMPLETER PUIS A COMMENTER

	// END COMPLETER
}








/**
 * Appel des diffrentes fonctions de dessin
*/
void dessiner( )
{
	switch( type )
	{
	case TRANSF:
		dessinerTransf();
		break;
	case SYSTEME:
		dessinerSysteme();
		break;
	case TERRE:
		dessinerSysteme();
		break;
	default:
		dessinerTransf(); // Par dfaut
		break;
	}
	glutPostRedisplay();
}


/**
 * Animation
 */
float dt = 0.01;

void animerAstre( Astre *a )
{
	a->selfa += dt*a->selfva;
	a->a += dt*a->va;
}


void animer()
{
	for( unsigned int i=0 ; i<nAstres ; ++i )
	{
		animerAstre( astres+i );
	}
}




/**
 * Initiliasation et suppression
 */

void initDonnees()
{
	astres = (Astre*) malloc( sizeof(Astre)*MAX_ASTRES );
	initSysteme( astres, &nAstres );
	soleil = astres+0;
	terre = astres+1;
}

void finDonnees()
{
}



void placerCamera()
{
	glLoadIdentity();
	
	// Par dfaut,  commenter plus tard
	// Recule la camra
	glTranslatef( 0, 0, -5 );
	
	
	// A COMPLETER
	// END COMPLETER

	
}





/**
 * Initialise la/les lumires
 */
void initLights()
{
    // Active la gestion de la lumire
    glEnable( GL_LIGHTING );
    // Active la premire lumire
    glEnable( GL_LIGHT0 );
    // Pour plus tard : glColor3f modifie le diffus du matriaux
    glEnable(GL_COLOR_MATERIAL);
    
    
    // Dfini l'clairage de la premire lampe
    float LightPos0[4] = {0,0,0,1};	// Position
    float LightDiff0[4] = {1,1,1,1};	// Couleur diffuse
    //float LightDiff0[4] = {1,0,1,1};	// Couleur diffuse (2)
    float LightSpec0[4] = {1,1,1,1};	// Couleur spculaire
    
    // "glLightfv" :  la fin "fv" signifie "float" et "pointeur"
    // c'est--dire que le dernier paramtre sera un tableau de 4 floats
    glLightfv(GL_LIGHT0, GL_POSITION, LightPos0);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, LightDiff0);
    glLightfv(GL_LIGHT0, GL_SPECULAR, LightSpec0);
    
}


void display(void);
void reshape(int w, int h);
void keyboard(unsigned char key, int x, int y);

/**
 * Programme principal
 */
int main(int argc, char** argv)
{
	
    animal::parse("Maillages et illumination. Voici la liste des options: ")
    .option(&W_fen,'L',"Largeur","largeur de la fentre en pixels")
    .option(&H_fen,'H',"Hauteur","hauteur de la fentre en pixels")
    .option(&NX,'c',"colonnes","finesse de l'chantillonnage horizontal (nombre de colonnes")
    .option(&NY,'l',"lignes","finesse de l'chantillonnage vertical (nombre de lignes)")
    .option(&type,'t',"type","type de rendu")
    .option(&dt,'d',"dt","pas de temps")
    (argc,argv);

    initDonnees( ); 
    
    glutInit(&argc, argv);

    // couches du framebuffer utilisees par l'application
    glutInitDisplayMode( GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH );

    // position et taille de la fenetre
    glutInitWindowPosition(200, 100);
    glutInitWindowSize(W_fen,H_fen);
    glutCreateWindow(argv[0]);

    initLights();

    // Initialisation du point de vue
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glTranslatef(0,0,-4);
    tbInitTransform();     // initialisation du point de vue
    tbHelp();                      // affiche l'aide sur la traqueboule

    
    

    
    

    // cablage des callback
    glutReshapeFunc(reshape);
    glutKeyboardFunc(keyboard);
    glutDisplayFunc(display);
    glutMouseFunc(tbMouseFunc);    // traqueboule utilise la souris
    glutMotionFunc(tbMotionFunc);  // traqueboule utilise la souris
    glutIdleFunc( animer );

    // lancement de la boucle principale
    glutMainLoop();
    
    finDonnees();
    
    return 0;  // instruction jamais excute
}

static float x;
static float y;
static float z=0;
static float wlight=1;
void moveLight()
{
    x = 0;
    y = 0;

    //x = cos(t*wlight*M_PI);
    //y = sin(t*wlight*M_PI);
    
    float LightPos0[4] = {x,y,z,1};	// Position
    
    // "glLightfv" :  la fin "fv" signifie "float" et "pointeur"
    // c'est--dire que le dernier paramtre sera un tableau de 4 floats
    glLightfv(GL_LIGHT0, GL_POSITION, LightPos0);
    
}


/**
 * Fonctions de gestion opengl  ne pas toucher
 */
// Actions d'affichage
// Ne pas changer
void display(void)
{
    // Details sur le mode de trac
    glEnable( GL_DEPTH_TEST );            // effectuer le test de profondeur
    //glEnable(GL_CULL_FACE);
    //glCullFace(GL_BACK);
    glPolygonMode(GL_FRONT,GL_FILL);
    glPolygonMode(GL_BACK,GL_LINE);
    glShadeModel(GL_FLAT);

    // Effacer tout
    glClearColor (0.0, 0.0, 0.0, 0.0);
    glClear( GL_COLOR_BUFFER_BIT  | GL_DEPTH_BUFFER_BIT); // la couleur et le z
    
    
    
    glLoadIdentity();  // repere camera
    
    if( type == TERRE )
    {
    	placerCamera();
    }
    else
    {
    	tbVisuTransform(); // origine et orientation de la scene
    }
        
    moveLight();

    dessiner( );

    glutSwapBuffers();
}
// pour changement de taille ou desiconification
void reshape(int w, int h)
{
    glViewport(0, 0, (GLsizei) w, (GLsizei) h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    //glOrtho (-1.1, 1.1, -1.1,1.1, -1000.0, 1000.0);
    gluPerspective (50, (float)w/h, 1, 10);
    glMatrixMode(GL_MODELVIEW);
}

// prise en compte du clavier
void keyboard(unsigned char key, int x, int y)
{
    printf("key %d pressed at %d,%d\n",key,x,y);
    fflush(stdout);
    switch (key)
    {
    case 27:     // touche ESC
        exit(0);
    }
}

